import { FORMS } from  '../forms'
import {
    ActionFormData,
    MessageFormData,
    ModalFormData
} from "@minecraft/server-ui"
import { system, world } from "@minecraft/server"
import { runCMDs, rawtext, runCMD, tellraw } from './axistools'

export function actionsChain(chain,player) {
    let name = player.name
    for (let i in chain) {
        let toValue = chain[i].value
        switch (chain[i].type) {
            case 'eval':
                eval(toValue)
                break
            case 'cmds':
                runCMDs(toValue,player)
                break
            case 'say':
                rawtext(toValue,name)
                break
            case 'cmd':
                runCMD(toValue,player)
                break
            case 'form':
                openJSON(toValue,player)
                break
            case 'tellraw':
                tellraw(toValue,name)
                break
            case 'tellraw_sel':
                tellraw(toValue[1],toValue[0])
                break
        }
    }
}

export function openJSON(systemName,player) {
    system.run(() => {
        let name = player.name
        let formData = FORMS[systemName]
        //JSON.stringify(formData)
        if (formData.type == undefined || formData.type == 'buttons') {
            const formTale = new ActionFormData()
            formTale.title(formData.title)
            formTale.body(formData.body)

            let buttons = formData.buttons
            for (let i in buttons) {
                let thisButt = buttons[i]
                if (thisButt.icon != undefined || thisButt.icon != '') {
                    formTale.button(thisButt.button_name,thisButt.icon)
                } else {
                    formTale.button(thisButt.button_name)
                }
            }

            formTale.show(player).then(gg => {
                if (gg.selection != undefined) {
                    actionsChain(buttons[gg.selection].on_click,player)
                } else if (formData.on_close != undefined) {
                    actionsChain(formData.on_close,player)
                }
            })
        } else if (formData.type == 'dynamic') {

            const formTale = new ModalFormData()
            formTale.title(formData.title)

            let players = world.getPlayers()
            const playernames = Array.from(players, plr => plr.name)
            players = [...players]

            let elements = formData.elements
            for (let i in elements) {
                const thisElem = elements[i]
                switch (thisElem.type) {
                    case 'players':
                        formTale.dropdown(thisElem.name, playernames)
                    break;
                    case 'slider':
                        let range = thisElem.range
                        formTale.slider(thisElem.name, range.min,range.max,range.step,range.default)
                }
            }
            formTale.show(player).then(gg => {
                let formBlank = gg.formValues
                for (let i in elements) {
                    const thisElem = elements[i]
                    switch (thisElem.type) {
                        case 'players':
                            actionsChain(thisElem.on_choice,players[formBlank[i]])
                        break;
                        case 'slider':
                            runCMD(`scoreboard players ${thisElem.scoreboard[2]} ${thisElem.scoreboard[0]} ${thisElem.scoreboard[1]} ${formBlank[i]}`,player,true)
                        break;
                    }
                }
            })
        }
    })
}