import { world, system } from "@minecraft/server"
import { actionsChain, openJSON } from "./formBuilder";
import { TRIGGERS } from "../formsTriggers";

system.afterEvents.scriptEventReceive.subscribe((event) => {
    const {
        id,           // returns string (wiki:test)
        initiator,    // returns Entity
        message,      // returns string (Hello World)
        sourceBlock,  // returns Block
        sourceEntity, // returns Entity
        sourceType,   // returns MessageSourceType
    } = event;
    switch (id) {
        case 'axiscube:easyform':
            openJSON(message, sourceEntity)
            break
    }
})

world.beforeEvents.itemUse.subscribe(({itemStack, source}) => {
    for (let i in TRIGGERS['itemEvent']) {
        if (itemStack.typeId == i) {
            if (typeof TRIGGERS['itemEvent'][i] == 'string') {
                openJSON(TRIGGERS['itemEvent'][i],source)
            } else {
                actionsChain(TRIGGERS['itemEvent'][i], source)
            }
        }
    }
})

world.afterEvents.entityHurt.subscribe(eventData => {
    const {
        hurtEntity,
        damage,
        damageSource: {
          damagingEntity,
          damagingProjectile,
          cause
        }
      } = eventData
    if (hurtEntity != undefined && damagingEntity.typeId === 'minecraft:player') {
        for (let i in TRIGGERS['entityEvent']) {
            if (hurtEntity.typeId == i) { 
                if (typeof TRIGGERS['entityEvent'][i] == 'string') {
                    openJSON(TRIGGERS['entityEvent'][i],damagingEntity)
                } else {
                    actionsChain(TRIGGERS['entityEvent'][i], damagingEntity)
                }
             }
        }
    }
})